Codeforces Round #363 (Div. 2) C. Vacations(DP)

C. Vacations
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Vasya has n days of vacations! So he decided to improve his IT skills and do sport. Vasya knows the following information about each of this n days: whether that gym opened and whether a contest was carried out in the Internet on that day. For the i-th day there are four options:

  1. on this day the gym is closed and the contest is not carried out;
  2. on this day the gym is closed and the contest is carried out;
  3. on this day the gym is open and the contest is not carried out;
  4. on this day the gym is open and the contest is carried out.

On each of days Vasya can either have a rest or write the contest (if it is carried out on this day), or do sport (if the gym is open on this day).

Find the minimum number of days on which Vasya will have a rest (it means, he will not do sport and write the contest at the same time). The only limitation that Vasya has — he does not want to do the same activity on two consecutive days: it means, he will not do sport on two consecutive days, and write the contest on two consecutive days.

Input

The first line contains a positive integer n (1 ≤ n ≤ 100) — the number of days of Vasya's vacations.

The second line contains the sequence of integers a1, a2, ..., an (0 ≤ ai ≤ 3) separated by space, where:

  • ai equals 0, if on the i-th day of vacations the gym is closed and the contest is not carried out;
  • ai equals 1, if on the i-th day of vacations the gym is closed, but the contest is carried out;
  • ai equals 2, if on the i-th day of vacations the gym is open and the contest is not carried out;
  • ai equals 3, if on the i-th day of vacations the gym is open and the contest is carried out.
Output

Print the minimum possible number of days on which Vasya will have a rest. Remember that Vasya refuses:

  • to do sport on any two consecutive days,
  • to write the contest on any two consecutive days.
Examples
input
4
1 3 2 0
output
2
input
7
1 3 3 2 1 2 3
output
0
input
2
2 2
output
1
Note

In the first test Vasya can write the contest on the day number 1 and do sport on the day number 3. Thus, he will have a rest for only 2 days.

In the second test Vasya should write contests on days number 1, 3, 5 and 7, in other days do sport. Thus, he will not have a rest for a single day.

In the third test Vasya can do sport either on a day number 1 or number 2. He can not do sport in two days, because it will be contrary to the his limitation. Thus, he will have a rest for only one day.


题意:

0代表必须休息,1代表只能做运动,2代表只能写作业,3代表两种都可以,然后不能连续两天做同样的事情,除了休息,问你最少休息多少天

题解:

当时比赛的时候做,看到数据n在100以内,然后直接上了一个暴搜,卧槽,殊不知这可以出数据让你暴搜会达到2的100次方,所以这题只能DP

设dp[i][j]表示第i天做第j种事的最小休息天数,因为3代表两种都可以,就更新两种状态就行了

 1 #include<cstdio>
 2 #define F(i,a,b) for(int i=a;i<=b;++i)
 3 
 4 int a[110],dp[110][3],inf=1e9+7;
 5 void up(int &x,int y){if(x>y)x=y;}
 6 
 7 int main(){
 8     int n;
 9     scanf("%d",&n);
10     F(i,1,n)scanf("%d",a+i);
11     F(i,1,n)F(j,0,2)dp[i][j]=inf;
12     dp[0][0]=0;
13     F(i,0,n-1)F(j,0,2)
14         if(dp[i][j]!=inf){
15             if(a[i+1]==0)up(dp[i+1][0],dp[i][j]+1);
16             if(a[i+1]==1){
17                 if(j==1)up(dp[i+1][0],dp[i][j]+1);
18                 else up(dp[i+1][1],dp[i][j]);
19             }
20             if(a[i+1]==2){
21                 if(j==2)up(dp[i+1][0],dp[i][j]+1);
22                 else up(dp[i+1][2],dp[i][j]);
23             }
24             if(a[i+1]==3){
25                 if(j==1)up(dp[i+1][2],dp[i][j]);
26                 else if(j==2)up(dp[i+1][1],dp[i][j]);
27                 else{
28                     up(dp[i+1][1],dp[i][j]);
29                     up(dp[i+1][2],dp[i][j]);
30                 }
31             }
32         }
33     int mi=inf;
34     F(i,0,2)up(mi,dp[n][i]);
35     printf("%d
",mi);
36     return 0;
37 }
View Code
原文地址:https://www.cnblogs.com/bin-gege/p/5696072.html